SystemOrganization addCategory: #SimplePersistenceFuel!
SystemOrganization addCategory: #'SimplePersistenceFuel-Tests'!

TestCase subclass: #SimplePersistenceFuelTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplePersistenceFuel-Tests'!

!SimplePersistenceFuelTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 15:34'!
testSaveObjectsFuel
	| db numberToStore stringToStore |
	db := SimplePersistenceFuelTestDatabase.
	numberToStore := 1.
	stringToStore := 'you can use any object, not just numbers and strings!!'.
	db store: numberToStore and: stringToStore.
	db saveRepository.
	db reset.
	db restoreLastBackup.
	self assert: db number = numberToStore.
	self assert: db string = stringToStore! !

!SimplePersistenceFuelTests methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 15:34'!
testSaveObjectsInBackgroundFuel
	| db numberToStore stringToStore |
	db := SimplePersistenceFuelTestDatabase.
	numberToStore := 1.
	stringToStore := 'you can use any object, not just numbers and strings!!'.
	db store: numberToStore and: stringToStore.
	db takeSnapshot.
	db reset.
	db restoreLastBackup.
	self assert: db number = numberToStore.
	self assert: db string = stringToStore! !

SPFileDatabase subclass: #SPFileDatabaseFuel
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplePersistenceFuel'!

!SPFileDatabaseFuel class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
lastBackup
	| lastBackup |
	lastBackup := self lastBackupFile.
	lastBackup ifNil: [ ^ nil ].
	^ FLMaterializer materializeFromFileNamed: (self backupDirectory fullNameFor: lastBackup)! !

!SPFileDatabaseFuel class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:09'!
saveRepository
	| version |
	lock ifNil: [ lock := Semaphore forMutualExclusion ].
	lock
		critical: [ 
			self trimBackups.
			version := self lastBackupFile ifNil: [ 1 ] ifNotNil: [ self lastBackupFile name asInteger + 1 ].
			FLSerializer
				serialize: self repositories
				toFileNamed: (self backupDirectory fullPathFor: self name) , '.' , version asString ]! !

SPFileDatabaseFuel subclass: #SimplePersistenceFuelTestDatabase
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SimplePersistenceFuel-Tests'!

SimplePersistenceFuelTestDatabase class
	instanceVariableNames: 'number string'!

SimplePersistenceFuelTestDatabase class
	instanceVariableNames: 'number string'!

!SimplePersistenceFuelTestDatabase class methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
number

	^ number.! !

!SimplePersistenceFuelTestDatabase class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
repositories

	^ { number. string }! !

!SimplePersistenceFuelTestDatabase class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
reset

	number := string := nil.! !

!SimplePersistenceFuelTestDatabase class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
restoreRepositories: someRepositories

	number := someRepositories at: 1.
	string := someRepositories at: 2.! !

!SimplePersistenceFuelTestDatabase class methodsFor: 'as yet unclassified' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
store: aNumber and: aString

	number := aNumber.
	string := aString.! !

!SimplePersistenceFuelTestDatabase class methodsFor: 'accessing' stamp: 'PaulDeBruicker 11/9/2011 11:11'!
string

	^ string.! !
